local addon, engine = ...
engine[1] = CreateFrame("Frame", nil, UIParent)
engine[2] = {}
engine[3] = {}

engine[1]:RegisterEvent("ADDON_LOADED")

function engine:unpack()
	return self[1], self[2], self[3]
end

bdlc = engine[1]
l = engine[2]
f = engine[3]

bdlc.player_realm = GetRealmName()
bdlc.local_player = UnitName("player").."-"..bdlc.player_realm
--------------------------------------
-- EN Localization Defaults
--------------------------------------
-- important functionality documentation
l['tierProtector'] = "Protector"
l['tierConqueror'] = "Conqueror"
l['tierVanquisher'] = "Vanquisher"
l['artifactRelic'] = "Artifact Relic" -- eg 'Life "Artifact Relic"' - for tooltip scanning
l['artifactWind'] = "Wind" -- Storm relics were once called 'wind relics'. The API still returns this
l['artifactWind'] = "Storm" -- To rename 'Wind' relics to 'Storm'
l['tierHelm'] = "Helm"
l['tierShoulders'] = "Shoulders"
l['tierLegs'] = "Leggings"
l['tierCloak'] = "Cloak"
l['tierChest'] = "Chest"
l['tierGloves'] = "Guantlets"

-- frame/button localizations
l['frameMain'] = "Mainspec"
l['frameMinorUp'] = "Minor Up"
l['frameOffspec'] = "Offspec"
l['frameReroll'] = "Reroll"
l['frameTransmog'] = "Transmog"
l['frameNote'] = "Note"
l['framePass'] = "Pass"
l['frameVote'] = "Vote"
l['frameVotes'] = "Votes"
l['frameNotes'] = "Notes"
l['frameOkay'] = "Okay"
l['frameInterest'] = "Interest"
l['frameCurrentGear'] = "Current Gear"
l['frameConsidering'] = "considering..."
l['frameRank'] = "Rank"
l['frameName'] = "Name"
l['frameAward'] = "Award to "
l['frameYes'] = "Yes"
l['frameNo'] = "No"
l['frameEndSession'] = "End Session"
l['frameIlvl'] = "ilvl"
l['frameItem'] = "Item Name"
l['frameLC'] = "Loot Council"


bdlc.message_prefix = "BDLC";
bdlc.item_drops = {}
bdlc.enchanters = {}
bdlc.award_slot = nil
bdlc.sendTo = "RAID"
bdlc.loot_sessions = { --[[[	itemLink] = itemUID	--]]}
bdlc.loot_council_votes = { --[[	itemLink[playerName] = {councilNames}	--]]}
bdlc.loot_council = {}
bdlc.loot_slots = {}
bdlc.loot_considering = {}
bdlc.loot_want = {}
bdlc.items_waiting = {}
bdlc.player_items_waiting = {}
bdlc.master_looter_qn = {}

bdlc.itemUID_Map = {}

-- Config
bdlc.config = {
	flat = "Interface\\Buttons\\WHITE8x8",
	height = 400,
	width = 600,
	debug = false,
	version = "1.7"
}
bdlc.defaults = {
	council_min_rank = 2,
	custom_council = {},
	custom_qn = {
		["BiS"] = true,
		["2p"] = true,
		["4p"] = true,
	}
}